---
title: Detect Mis-Keyed Form Entries
product: Form Library
description: Detect typos, misspellings, and formatting variations in SurveyJS forms by comparing new entries against existing records. View this JavaScript demo to learn more.
framework: Vanilla JS
source: https://surveyjs.io/form-library/examples/detect-miskeyed-form-entries/vanillajs
index: https://surveyjs.io/form-library/examples/overview.md
---

# Detect Mis-Keyed Form Entries (Vanilla JS)

Mis-keyed variation detection identifies values that likely refer to the same person or organization but contain typos, misspellings, or inconsistent formatting—for example, `John Smth` instead of `John Smith`, or `ACME Corp` instead of `ACME Corporation`. This feature is useful for detecting human data entry mistakes before they create duplicates or bad records in CRM contacts, clinical registrations, insurance claims, or research participant records.

To implement approximate string matching in SurveyJS, register a [custom asynchronous function](/form-library/documentation/design-survey/conditional-logic#asynchronous-functions) and add an async expression validator to a question's [`validators`](/form-library/documentation/api-reference/question#validators) array.

## How This Demo Works

1. The form collects contact details (full name, date of birth, email, organization).
2. Each field is assigned an async function that validates its value.
3. The function compares the field value against the corresponding property in an in-demo contact list using string similarity (with a short delay to simulate async work).
4. If a near match is found, the function returns `false`, and the field displays the validator [`text`](/form-library/documentation/api-reference/textvalidator#text).

Try values like `John Smth`, `Kathrine Brown`, `Sofia Martinezz`, or `ACME Corp`.

In this demo, validators use [`"notificationType": "warning"`](/form-library/documentation/api-reference/textvalidator#notificationType), so validation messages do not block form submission. To prevent the form from being submitted until the issue is resolved, use the default `"error"` notification type.

[Validator Notification Types](https://surveyjs.io/survey-creator/documentation/end-user-guide/data-validation-in-forms#validator-notification-types (linkStyle))

## Connect to an API Endpoint

Replace the demo helper with a `fetch` call (or an equivalent call using your SDK) to compare values against your CRM, patient registry, or matching service. Call `this.returnResult(boolean)` when validation completes:

```js
function isNotMisKeyedName([fullName]) {
  if (!fullName) {
    this.returnResult(true);
    return;
  }
  fetch("/api/validation/miskeyed", {
    method: "POST",
    headers: { "Content-Type": "application/json" },
    body: JSON.stringify({ field: "fullName", value: fullName })
  })
    .then((response) => response.json())
    .then((data) => {
      // data.ok === true means no problematic near-match
      this.returnResult(!!data.ok);
    })
    .catch(() => {
      this.returnResult(false);
    });
}

registerFunction({
  name: "isNotMisKeyedName",
  func: isNotMisKeyedName,
  isAsync: true
});
```

Add expression validators to your survey JSON, for example: `"expression": "isNotMisKeyedName({fullName})"`. Refer to the JSON schema in the Code tab for more examples.

Expression validators use a fixed `text` message. If your API needs to return a personalized message with a dynamically inserted value, such as "Did you mean John Smith?", use the [`onServerValidateQuestions`](/form-library/examples/javascript-server-side-form-validation/) event instead. See the [Double-Entry Verification](/form-library/examples/double-entry-verification/) and [Detect Duplicate Form Records](/form-library/examples/detect-duplicate-form-records/) demos for examples.

## Related Demos

- [Server-Side Form Validation Using an Event](https://surveyjs.io/form-library/examples/javascript-server-side-form-validation/)
- [Server-Side Form Validation Using Expressions](https://surveyjs.io/form-library/examples/javascript-async-form-validation/)

## Files

### `public/index.html`

```html
<div id="surveyElement" style="position: absolute; top: 0; left: 0; right: 0; bottom: 0; min-height: 100%; height:100%"></div>
```

### `src/index.css`

```css
/* You can add your custom CSS here. */
```

### `src/index.js`

```js
import { Model } from "survey-core";
import "survey-js-ui";
import "survey-core/survey-core.min.css";
import "./index.css";
import { json } from "./json";
import { registerFunction } from "survey-core";


// Async expression validators (registerFunction + isAsync).
// Demo uses an in-memory contact list; see the Documentation tab to connect your own API.

const EXISTING_CONTACTS = [
  { fullName: "John Smith", dateOfBirth: "1987-04-12", email: "john.smith@email.com", organization: "ACME Corporation" },
  { fullName: "Katherine Brown", dateOfBirth: "1991-09-03", email: "kbrown@email.com", organization: "Northline Logistics" },
  { fullName: "Sofia Martinez", dateOfBirth: "1985-01-22", email: "s.martinez@email.com", organization: "SurveyJS Ltd" },
  { fullName: "Jonathan Smith", dateOfBirth: "1987-04-11", email: "j.smith@email.com", organization: "ACME Corporation" }
];

function normalizeText(value) {
  return String(value || "")
    .toLowerCase()
    .replace(/[^a-z0-9\s]/g, " ")
    .replace(/\s+/g, " ")
    .trim();
}

function levenshteinDistance(a, b) {
  const rows = a.length + 1;
  const cols = b.length + 1;
  const matrix = Array.from({ length: rows }, () => Array(cols).fill(0));

  for (let i = 0; i < rows; i++) matrix[i][0] = i;
  for (let j = 0; j < cols; j++) matrix[0][j] = j;

  for (let i = 1; i < rows; i++) {
    for (let j = 1; j < cols; j++) {
      const cost = a[i - 1] === b[j - 1] ? 0 : 1;
      matrix[i][j] = Math.min(
        matrix[i - 1][j] + 1,
        matrix[i][j - 1] + 1,
        matrix[i - 1][j - 1] + cost
      );
    }
  }

  return matrix[a.length][b.length];
}

function similarityRatio(left, right) {
  const a = normalizeText(left);
  const b = normalizeText(right);
  if (!a || !b) return 0;
  if (a === b) return 1;
  const distance = levenshteinDistance(a, b);
  const editScore = 1 - distance / Math.max(a.length, b.length);
  // Catch shortened forms such as "ACME Corp" vs "ACME Corporation"
  // (Levenshtein alone scores these too low).
  const abbreviationScore = abbreviationSimilarity(a, b);
  return Math.max(editScore, abbreviationScore);
}

function abbreviationSimilarity(a, b) {
  const tokensA = a.split(" ");
  const tokensB = b.split(" ");
  if (tokensA.length !== tokensB.length || tokensA.length === 0) return 0;

  let matchedChars = 0;
  let totalChars = 0;
  for (let i = 0; i < tokensA.length; i++) {
    const shorter = tokensA[i].length <= tokensB[i].length ? tokensA[i] : tokensB[i];
    const longer = tokensA[i].length <= tokensB[i].length ? tokensB[i] : tokensA[i];
    if (!longer.startsWith(shorter) || shorter.length < 3) return 0;
    matchedChars += shorter.length;
    totalChars += longer.length;
  }
  if (matchedChars === totalChars) return 0; // identical after normalize
  return matchedChars / totalChars >= 0.45 ? 0.85 : 0;
}

function findSimilarByField(value, fieldName) {
  if (!value) return null;

  let best = null;
  EXISTING_CONTACTS.forEach((contact) => {
    const score = similarityRatio(value, contact[fieldName]);
    if (score >= 0.72 && score < 0.98 && (!best || score > best.score)) {
      best = { contact, score };
    }
  });
  return best;
}

// In-demo async check (replace with fetch to your matching API in production).
function mockValidationApi(value, fieldName) {
  return new Promise((resolve) => {
    setTimeout(() => {
      if (!value) {
        resolve({ ok: true });
        return;
      }
      const match = findSimilarByField(value, fieldName);
      resolve({ ok: !match });
    }, 450);
  });
}

function isNotMisKeyedName([fullName]) {
  if (!fullName) {
    this.returnResult(true);
    return;
  }

  mockValidationApi(fullName, "fullName")
    .then((result) => {
      this.returnResult(!!result.ok);
    })
    .catch(() => {
      this.returnResult(false);
    });
}

function isNotMisKeyedOrganization([organization]) {
  if (!organization) {
    this.returnResult(true);
    return;
  }

  mockValidationApi(organization, "organization")
    .then((result) => {
      this.returnResult(!!result.ok);
    })
    .catch(() => {
      this.returnResult(false);
    });
}

registerFunction({
  name: "isNotMisKeyedName",
  func: isNotMisKeyedName,
  isAsync: true
});

registerFunction({
  name: "isNotMisKeyedOrganization",
  func: isNotMisKeyedOrganization,
  isAsync: true
});

const survey = new Model(json);
survey.onComplete.add((sender, options) => {
    console.log(JSON.stringify(sender.data, null, 3));
});

survey.render(document.getElementById("surveyElement"));
```

### `src/json.js`

```js
export const json = {
  "title": "Contact Registration",
  "description": "Try mistyped names such as \"Jon Smth\" or \"Kathrine Brown\". An async expression validator checks for similar contacts when you leave the field.",
  "checkErrorsMode": "onValueChanged",
  "completeText": "Register Contact",
  "pages": [
    {
      "name": "contact",
      "elements": [
        {
          "type": "text",
          "name": "fullName",
          "title": "Full name",
          "isRequired": true,
          "placeholder": "e.g. Jon Smth",
          "validators": [
            {
              "type": "expression",
              "text": "A similar contact may already exist. Check the spelling or verify that this is the intended person.",
              "expression": "isNotMisKeyedName({fullName})",
              "notificationType": "warning"
            }
          ]
        },
        {
          "type": "text",
          "name": "dateOfBirth",
          "title": "Date of birth",
          "inputType": "date"
        },
        {
          "type": "text",
          "name": "email",
          "title": "Email",
          "inputType": "email",
          "validators": [
            {
              "type": "email"
            }
          ]
        },
        {
          "type": "text",
          "name": "organization",
          "title": "Organization",
          "placeholder": "e.g. ACME Corp",
          "validators": [
            {
              "type": "expression",
              "text": "A similar organization may already exist. Check the spelling or verify that this is the intended organization.",
              "expression": "isNotMisKeyedOrganization({organization})",
              "notificationType": "warning"
            }
          ]
        }
      ]
    }
  ]
}
;
```

### `src/theme.js`

```js
export const themeJson = {};
```

### `package.json`

```json
{
  "dependencies": {
    "survey-core": "latest",
    "survey-js-ui": "latest"
  }
}
```

## Other Frameworks

- [Angular](https://surveyjs.io/form-library/examples/detect-miskeyed-form-entries/angular.md)
- [React](https://surveyjs.io/form-library/examples/detect-miskeyed-form-entries/reactjs.md)
- [Vue 3](https://surveyjs.io/form-library/examples/detect-miskeyed-form-entries/vue3js.md)
- [jQuery](https://surveyjs.io/form-library/examples/detect-miskeyed-form-entries/jquery.md)


---
title: Detect Mis-Keyed Form Entries
product: Form Library
description: Detect typos, misspellings, and formatting variations in SurveyJS forms by comparing new entries against existing records. View this JavaScript demo to learn more.
framework: React
source: https://surveyjs.io/form-library/examples/detect-miskeyed-form-entries/reactjs
index: https://surveyjs.io/form-library/examples/overview.md
---

# Detect Mis-Keyed Form Entries (React)

Mis-keyed variation detection identifies values that likely refer to the same person or organization but contain typos, misspellings, or inconsistent formatting—for example, `John Smth` instead of `John Smith`, or `ACME Corp` instead of `ACME Corporation`. This feature is useful for detecting human data entry mistakes before they create duplicates or bad records in CRM contacts, clinical registrations, insurance claims, or research participant records.

To implement approximate string matching in SurveyJS, register a [custom asynchronous function](/form-library/documentation/design-survey/conditional-logic#asynchronous-functions) and add an async expression validator to a question's [`validators`](/form-library/documentation/api-reference/question#validators) array.

## How This Demo Works

1. The form collects contact details (full name, date of birth, email, organization).
2. Each field is assigned an async function that validates its value.
3. The function compares the field value against the corresponding property in an in-demo contact list using string similarity (with a short delay to simulate async work).
4. If a near match is found, the function returns `false`, and the field displays the validator [`text`](/form-library/documentation/api-reference/textvalidator#text).

Try values like `John Smth`, `Kathrine Brown`, `Sofia Martinezz`, or `ACME Corp`.

In this demo, validators use [`"notificationType": "warning"`](/form-library/documentation/api-reference/textvalidator#notificationType), so validation messages do not block form submission. To prevent the form from being submitted until the issue is resolved, use the default `"error"` notification type.

[Validator Notification Types](https://surveyjs.io/survey-creator/documentation/end-user-guide/data-validation-in-forms#validator-notification-types (linkStyle))

## Connect to an API Endpoint

Replace the demo helper with a `fetch` call (or an equivalent call using your SDK) to compare values against your CRM, patient registry, or matching service. Call `this.returnResult(boolean)` when validation completes:

```js
function isNotMisKeyedName([fullName]) {
  if (!fullName) {
    this.returnResult(true);
    return;
  }
  fetch("/api/validation/miskeyed", {
    method: "POST",
    headers: { "Content-Type": "application/json" },
    body: JSON.stringify({ field: "fullName", value: fullName })
  })
    .then((response) => response.json())
    .then((data) => {
      // data.ok === true means no problematic near-match
      this.returnResult(!!data.ok);
    })
    .catch(() => {
      this.returnResult(false);
    });
}

registerFunction({
  name: "isNotMisKeyedName",
  func: isNotMisKeyedName,
  isAsync: true
});
```

Add expression validators to your survey JSON, for example: `"expression": "isNotMisKeyedName({fullName})"`. Refer to the JSON schema in the Code tab for more examples.

Expression validators use a fixed `text` message. If your API needs to return a personalized message with a dynamically inserted value, such as "Did you mean John Smith?", use the [`onServerValidateQuestions`](/form-library/examples/javascript-server-side-form-validation/) event instead. See the [Double-Entry Verification](/form-library/examples/double-entry-verification/) and [Detect Duplicate Form Records](/form-library/examples/detect-duplicate-form-records/) demos for examples.

## Related Demos

- [Server-Side Form Validation Using an Event](https://surveyjs.io/form-library/examples/javascript-server-side-form-validation/)
- [Server-Side Form Validation Using Expressions](https://surveyjs.io/form-library/examples/javascript-async-form-validation/)

## Files

### `public/index.html`

```html
<div id="surveyElement" style="position: absolute; top: 0; left: 0; right: 0; bottom: 0; min-height: 100%; height:100%"></div>
```

### `src/SurveyComponent.jsx`

```js
import React from "react";
import { Model } from "survey-core";
import { Survey } from "survey-react-ui";
import "survey-core/survey-core.min.css";
import "./index.css";
import { json } from "./json";
import { registerFunction } from "survey-core";


// Async expression validators (registerFunction + isAsync).
// Demo uses an in-memory contact list; see the Documentation tab to connect your own API.

const EXISTING_CONTACTS = [
  { fullName: "John Smith", dateOfBirth: "1987-04-12", email: "john.smith@email.com", organization: "ACME Corporation" },
  { fullName: "Katherine Brown", dateOfBirth: "1991-09-03", email: "kbrown@email.com", organization: "Northline Logistics" },
  { fullName: "Sofia Martinez", dateOfBirth: "1985-01-22", email: "s.martinez@email.com", organization: "SurveyJS Ltd" },
  { fullName: "Jonathan Smith", dateOfBirth: "1987-04-11", email: "j.smith@email.com", organization: "ACME Corporation" }
];

function normalizeText(value) {
  return String(value || "")
    .toLowerCase()
    .replace(/[^a-z0-9\s]/g, " ")
    .replace(/\s+/g, " ")
    .trim();
}

function levenshteinDistance(a, b) {
  const rows = a.length + 1;
  const cols = b.length + 1;
  const matrix = Array.from({ length: rows }, () => Array(cols).fill(0));

  for (let i = 0; i < rows; i++) matrix[i][0] = i;
  for (let j = 0; j < cols; j++) matrix[0][j] = j;

  for (let i = 1; i < rows; i++) {
    for (let j = 1; j < cols; j++) {
      const cost = a[i - 1] === b[j - 1] ? 0 : 1;
      matrix[i][j] = Math.min(
        matrix[i - 1][j] + 1,
        matrix[i][j - 1] + 1,
        matrix[i - 1][j - 1] + cost
      );
    }
  }

  return matrix[a.length][b.length];
}

function similarityRatio(left, right) {
  const a = normalizeText(left);
  const b = normalizeText(right);
  if (!a || !b) return 0;
  if (a === b) return 1;
  const distance = levenshteinDistance(a, b);
  const editScore = 1 - distance / Math.max(a.length, b.length);
  // Catch shortened forms such as "ACME Corp" vs "ACME Corporation"
  // (Levenshtein alone scores these too low).
  const abbreviationScore = abbreviationSimilarity(a, b);
  return Math.max(editScore, abbreviationScore);
}

function abbreviationSimilarity(a, b) {
  const tokensA = a.split(" ");
  const tokensB = b.split(" ");
  if (tokensA.length !== tokensB.length || tokensA.length === 0) return 0;

  let matchedChars = 0;
  let totalChars = 0;
  for (let i = 0; i < tokensA.length; i++) {
    const shorter = tokensA[i].length <= tokensB[i].length ? tokensA[i] : tokensB[i];
    const longer = tokensA[i].length <= tokensB[i].length ? tokensB[i] : tokensA[i];
    if (!longer.startsWith(shorter) || shorter.length < 3) return 0;
    matchedChars += shorter.length;
    totalChars += longer.length;
  }
  if (matchedChars === totalChars) return 0; // identical after normalize
  return matchedChars / totalChars >= 0.45 ? 0.85 : 0;
}

function findSimilarByField(value, fieldName) {
  if (!value) return null;

  let best = null;
  EXISTING_CONTACTS.forEach((contact) => {
    const score = similarityRatio(value, contact[fieldName]);
    if (score >= 0.72 && score < 0.98 && (!best || score > best.score)) {
      best = { contact, score };
    }
  });
  return best;
}

// In-demo async check (replace with fetch to your matching API in production).
function mockValidationApi(value, fieldName) {
  return new Promise((resolve) => {
    setTimeout(() => {
      if (!value) {
        resolve({ ok: true });
        return;
      }
      const match = findSimilarByField(value, fieldName);
      resolve({ ok: !match });
    }, 450);
  });
}

function isNotMisKeyedName([fullName]) {
  if (!fullName) {
    this.returnResult(true);
    return;
  }

  mockValidationApi(fullName, "fullName")
    .then((result) => {
      this.returnResult(!!result.ok);
    })
    .catch(() => {
      this.returnResult(false);
    });
}

function isNotMisKeyedOrganization([organization]) {
  if (!organization) {
    this.returnResult(true);
    return;
  }

  mockValidationApi(organization, "organization")
    .then((result) => {
      this.returnResult(!!result.ok);
    })
    .catch(() => {
      this.returnResult(false);
    });
}

registerFunction({
  name: "isNotMisKeyedName",
  func: isNotMisKeyedName,
  isAsync: true
});

registerFunction({
  name: "isNotMisKeyedOrganization",
  func: isNotMisKeyedOrganization,
  isAsync: true
});

function SurveyComponent() {
    const survey = new Model(json);
    survey.onComplete.add((sender, options) => {
        console.log(JSON.stringify(sender.data, null, 3));
    });
    return (<Survey model={survey} />);
}

export default SurveyComponent;
```

### `src/index.css`

```css
/* You can add your custom CSS here. */
```

### `src/index.js`

```js
import React from "react";
import { createRoot } from "react-dom/client";
import SurveyComponent from "./SurveyComponent";

const root = createRoot(document.getElementById("surveyElement"));
root.render(<SurveyComponent />);
```

### `src/json.js`

```js
export const json = {
  "title": "Contact Registration",
  "description": "Try mistyped names such as \"Jon Smth\" or \"Kathrine Brown\". An async expression validator checks for similar contacts when you leave the field.",
  "checkErrorsMode": "onValueChanged",
  "completeText": "Register Contact",
  "pages": [
    {
      "name": "contact",
      "elements": [
        {
          "type": "text",
          "name": "fullName",
          "title": "Full name",
          "isRequired": true,
          "placeholder": "e.g. Jon Smth",
          "validators": [
            {
              "type": "expression",
              "text": "A similar contact may already exist. Check the spelling or verify that this is the intended person.",
              "expression": "isNotMisKeyedName({fullName})",
              "notificationType": "warning"
            }
          ]
        },
        {
          "type": "text",
          "name": "dateOfBirth",
          "title": "Date of birth",
          "inputType": "date"
        },
        {
          "type": "text",
          "name": "email",
          "title": "Email",
          "inputType": "email",
          "validators": [
            {
              "type": "email"
            }
          ]
        },
        {
          "type": "text",
          "name": "organization",
          "title": "Organization",
          "placeholder": "e.g. ACME Corp",
          "validators": [
            {
              "type": "expression",
              "text": "A similar organization may already exist. Check the spelling or verify that this is the intended organization.",
              "expression": "isNotMisKeyedOrganization({organization})",
              "notificationType": "warning"
            }
          ]
        }
      ]
    }
  ]
}
;
```

### `src/theme.js`

```js
export const themeJson = {};
```

### `package.json`

```json
{
  "dependencies": {
    "react": "latest",
    "react-dom": "latest",
    "survey-core": "latest",
    "survey-react-ui": "latest"
  },
  "devDependencies": {
    "react-scripts": "latest"
  }
}
```

## Other Frameworks

- [Angular](https://surveyjs.io/form-library/examples/detect-miskeyed-form-entries/angular.md)
- [Vue 3](https://surveyjs.io/form-library/examples/detect-miskeyed-form-entries/vue3js.md)
- [jQuery](https://surveyjs.io/form-library/examples/detect-miskeyed-form-entries/jquery.md)
- [Vanilla JS](https://surveyjs.io/form-library/examples/detect-miskeyed-form-entries/vanillajs.md)


---
title: Detect Mis-Keyed Form Entries
product: Form Library
description: Detect typos, misspellings, and formatting variations in SurveyJS forms by comparing new entries against existing records. View this JavaScript demo to learn more.
framework: Angular
source: https://surveyjs.io/form-library/examples/detect-miskeyed-form-entries/angular
index: https://surveyjs.io/form-library/examples/overview.md
---

# Detect Mis-Keyed Form Entries (Angular)

Mis-keyed variation detection identifies values that likely refer to the same person or organization but contain typos, misspellings, or inconsistent formatting—for example, `John Smth` instead of `John Smith`, or `ACME Corp` instead of `ACME Corporation`. This feature is useful for detecting human data entry mistakes before they create duplicates or bad records in CRM contacts, clinical registrations, insurance claims, or research participant records.

To implement approximate string matching in SurveyJS, register a [custom asynchronous function](/form-library/documentation/design-survey/conditional-logic#asynchronous-functions) and add an async expression validator to a question's [`validators`](/form-library/documentation/api-reference/question#validators) array.

## How This Demo Works

1. The form collects contact details (full name, date of birth, email, organization).
2. Each field is assigned an async function that validates its value.
3. The function compares the field value against the corresponding property in an in-demo contact list using string similarity (with a short delay to simulate async work).
4. If a near match is found, the function returns `false`, and the field displays the validator [`text`](/form-library/documentation/api-reference/textvalidator#text).

Try values like `John Smth`, `Kathrine Brown`, `Sofia Martinezz`, or `ACME Corp`.

In this demo, validators use [`"notificationType": "warning"`](/form-library/documentation/api-reference/textvalidator#notificationType), so validation messages do not block form submission. To prevent the form from being submitted until the issue is resolved, use the default `"error"` notification type.

[Validator Notification Types](https://surveyjs.io/survey-creator/documentation/end-user-guide/data-validation-in-forms#validator-notification-types (linkStyle))

## Connect to an API Endpoint

Replace the demo helper with a `fetch` call (or an equivalent call using your SDK) to compare values against your CRM, patient registry, or matching service. Call `this.returnResult(boolean)` when validation completes:

```js
function isNotMisKeyedName([fullName]) {
  if (!fullName) {
    this.returnResult(true);
    return;
  }
  fetch("/api/validation/miskeyed", {
    method: "POST",
    headers: { "Content-Type": "application/json" },
    body: JSON.stringify({ field: "fullName", value: fullName })
  })
    .then((response) => response.json())
    .then((data) => {
      // data.ok === true means no problematic near-match
      this.returnResult(!!data.ok);
    })
    .catch(() => {
      this.returnResult(false);
    });
}

registerFunction({
  name: "isNotMisKeyedName",
  func: isNotMisKeyedName,
  isAsync: true
});
```

Add expression validators to your survey JSON, for example: `"expression": "isNotMisKeyedName({fullName})"`. Refer to the JSON schema in the Code tab for more examples.

Expression validators use a fixed `text` message. If your API needs to return a personalized message with a dynamically inserted value, such as "Did you mean John Smith?", use the [`onServerValidateQuestions`](/form-library/examples/javascript-server-side-form-validation/) event instead. See the [Double-Entry Verification](/form-library/examples/double-entry-verification/) and [Detect Duplicate Form Records](/form-library/examples/detect-duplicate-form-records/) demos for examples.

## Related Demos

- [Server-Side Form Validation Using an Event](https://surveyjs.io/form-library/examples/javascript-server-side-form-validation/)
- [Server-Side Form Validation Using Expressions](https://surveyjs.io/form-library/examples/javascript-async-form-validation/)

## Files

### `src/app/components/json.ts`

```ts
export const json = {
  "title": "Contact Registration",
  "description": "Try mistyped names such as \"Jon Smth\" or \"Kathrine Brown\". An async expression validator checks for similar contacts when you leave the field.",
  "checkErrorsMode": "onValueChanged",
  "completeText": "Register Contact",
  "pages": [
    {
      "name": "contact",
      "elements": [
        {
          "type": "text",
          "name": "fullName",
          "title": "Full name",
          "isRequired": true,
          "placeholder": "e.g. Jon Smth",
          "validators": [
            {
              "type": "expression",
              "text": "A similar contact may already exist. Check the spelling or verify that this is the intended person.",
              "expression": "isNotMisKeyedName({fullName})",
              "notificationType": "warning"
            }
          ]
        },
        {
          "type": "text",
          "name": "dateOfBirth",
          "title": "Date of birth",
          "inputType": "date"
        },
        {
          "type": "text",
          "name": "email",
          "title": "Email",
          "inputType": "email",
          "validators": [
            {
              "type": "email"
            }
          ]
        },
        {
          "type": "text",
          "name": "organization",
          "title": "Organization",
          "placeholder": "e.g. ACME Corp",
          "validators": [
            {
              "type": "expression",
              "text": "A similar organization may already exist. Check the spelling or verify that this is the intended organization.",
              "expression": "isNotMisKeyedOrganization({organization})",
              "notificationType": "warning"
            }
          ]
        }
      ]
    }
  ]
}
;
```

### `src/app/components/survey.component.css`

```css
/* You can add your custom CSS here. */
```

### `src/app/components/survey.component.html`

```html
<survey [model]="model" style="position: absolute; top: 0; left: 0; right: 0; bottom: 0; height:100%"></survey>
```

### `src/app/components/survey.component.ts`

```ts
import { Component, OnInit } from "@angular/core";
import { Model } from "survey-core";
import { json } from "./json";
import "./survey.component.css";
import "survey-core/survey-core.min.css";
import { registerFunction } from "survey-core";


// Async expression validators (registerFunction + isAsync).
// Demo uses an in-memory contact list; see the Documentation tab to connect your own API.

const EXISTING_CONTACTS = [
  { fullName: "John Smith", dateOfBirth: "1987-04-12", email: "john.smith@email.com", organization: "ACME Corporation" },
  { fullName: "Katherine Brown", dateOfBirth: "1991-09-03", email: "kbrown@email.com", organization: "Northline Logistics" },
  { fullName: "Sofia Martinez", dateOfBirth: "1985-01-22", email: "s.martinez@email.com", organization: "SurveyJS Ltd" },
  { fullName: "Jonathan Smith", dateOfBirth: "1987-04-11", email: "j.smith@email.com", organization: "ACME Corporation" }
];

function normalizeText(value) {
  return String(value || "")
    .toLowerCase()
    .replace(/[^a-z0-9\s]/g, " ")
    .replace(/\s+/g, " ")
    .trim();
}

function levenshteinDistance(a, b) {
  const rows = a.length + 1;
  const cols = b.length + 1;
  const matrix = Array.from({ length: rows }, () => Array(cols).fill(0));

  for (let i = 0; i < rows; i++) matrix[i][0] = i;
  for (let j = 0; j < cols; j++) matrix[0][j] = j;

  for (let i = 1; i < rows; i++) {
    for (let j = 1; j < cols; j++) {
      const cost = a[i - 1] === b[j - 1] ? 0 : 1;
      matrix[i][j] = Math.min(
        matrix[i - 1][j] + 1,
        matrix[i][j - 1] + 1,
        matrix[i - 1][j - 1] + cost
      );
    }
  }

  return matrix[a.length][b.length];
}

function similarityRatio(left, right) {
  const a = normalizeText(left);
  const b = normalizeText(right);
  if (!a || !b) return 0;
  if (a === b) return 1;
  const distance = levenshteinDistance(a, b);
  const editScore = 1 - distance / Math.max(a.length, b.length);
  // Catch shortened forms such as "ACME Corp" vs "ACME Corporation"
  // (Levenshtein alone scores these too low).
  const abbreviationScore = abbreviationSimilarity(a, b);
  return Math.max(editScore, abbreviationScore);
}

function abbreviationSimilarity(a, b) {
  const tokensA = a.split(" ");
  const tokensB = b.split(" ");
  if (tokensA.length !== tokensB.length || tokensA.length === 0) return 0;

  let matchedChars = 0;
  let totalChars = 0;
  for (let i = 0; i < tokensA.length; i++) {
    const shorter = tokensA[i].length <= tokensB[i].length ? tokensA[i] : tokensB[i];
    const longer = tokensA[i].length <= tokensB[i].length ? tokensB[i] : tokensA[i];
    if (!longer.startsWith(shorter) || shorter.length < 3) return 0;
    matchedChars += shorter.length;
    totalChars += longer.length;
  }
  if (matchedChars === totalChars) return 0; // identical after normalize
  return matchedChars / totalChars >= 0.45 ? 0.85 : 0;
}

function findSimilarByField(value, fieldName) {
  if (!value) return null;

  let best = null;
  EXISTING_CONTACTS.forEach((contact) => {
    const score = similarityRatio(value, contact[fieldName]);
    if (score >= 0.72 && score < 0.98 && (!best || score > best.score)) {
      best = { contact, score };
    }
  });
  return best;
}

// In-demo async check (replace with fetch to your matching API in production).
function mockValidationApi(value, fieldName) {
  return new Promise((resolve) => {
    setTimeout(() => {
      if (!value) {
        resolve({ ok: true });
        return;
      }
      const match = findSimilarByField(value, fieldName);
      resolve({ ok: !match });
    }, 450);
  });
}

function isNotMisKeyedName([fullName]) {
  if (!fullName) {
    this.returnResult(true);
    return;
  }

  mockValidationApi(fullName, "fullName")
    .then((result) => {
      this.returnResult(!!result.ok);
    })
    .catch(() => {
      this.returnResult(false);
    });
}

function isNotMisKeyedOrganization([organization]) {
  if (!organization) {
    this.returnResult(true);
    return;
  }

  mockValidationApi(organization, "organization")
    .then((result) => {
      this.returnResult(!!result.ok);
    })
    .catch(() => {
      this.returnResult(false);
    });
}

registerFunction({
  name: "isNotMisKeyedName",
  func: isNotMisKeyedName,
  isAsync: true
});

registerFunction({
  name: "isNotMisKeyedOrganization",
  func: isNotMisKeyedOrganization,
  isAsync: true
});

@Component({
    // tslint:disable-next-line:component-selector
    selector: "component-survey",
    templateUrl: "./survey.component.html",
    styleUrls: ["./survey.component.css"]
})
export class SurveyComponent implements OnInit {
    model: Model;
    ngOnInit() {
        const survey = new Model(json);
        survey.onComplete.add((sender, options) => {
            console.log(JSON.stringify(sender.data, null, 3));
        });
        this.model = survey;
    }
}
```

### `src/app/components/theme.ts`

```ts
export const themeJson = {};
```

### `src/app/app.component.css`

```css

```

### `src/app/app.component.html`

```html
<component-survey></component-survey>
```

### `src/app/app.component.ts`

```ts
import { Component } from "@angular/core";

@Component({
    selector: "app-root",
    templateUrl: "./app.component.html",
    styleUrls: ["./app.component.css"]
})
export class AppComponent {
    title = "CodeSandbox";
}
```

### `src/app/app.module.ts`

```ts
import { BrowserModule } from "@angular/platform-browser";
import { NgModule } from "@angular/core";

import { AppComponent } from "./app.component";
import { SurveyModule } from "survey-angular-ui";
import { SurveyComponent } from "./components/survey.component";

@NgModule({
    declarations: [AppComponent, SurveyComponent],
    imports: [BrowserModule, SurveyModule],
    providers: [],
    bootstrap: [AppComponent]
})
export class AppModule { }
```

### `src/environments/environment.prod.ts`

```ts
export const environment = {
    production: true
};
```

### `src/environments/environment.ts`

```ts
// The file contents for the current environment will overwrite these during build.
// The build system defaults to the dev environment which uses `environment.ts`, but if you do
// `ng build --env=prod` then `environment.prod.ts` will be used instead.
// The list of which env maps to which file can be found in `.angular-cli.json`.

export const environment = {
    production: false
};
```

### `src/index.html`

```html
<app-root></app-root>
```

### `src/main.ts`

```ts
import { enableProdMode } from "@angular/core";
import { platformBrowserDynamic } from "@angular/platform-browser-dynamic";

import { AppModule } from "./app/app.module";
import { environment } from "./environments/environment";

if (environment.production) {
    enableProdMode();
}

platformBrowserDynamic()
    .bootstrapModule(AppModule)
    .catch(err => console.log(err));
```

### `src/polyfills.ts`

```ts
/**
 * This file includes polyfills needed by Angular and is loaded before the app.
 * You can add your own extra polyfills to this file.
 *
 * This file is divided into 2 sections:
 *   1. Browser polyfills. These are applied before loading ZoneJS and are sorted by browsers.
 *   2. Application imports. Files imported after ZoneJS that should be loaded before your main
 *      file.
 *
 * The current setup is for so-called "evergreen" browsers; the last versions of browsers that
 * automatically update themselves. This includes Safari >= 10, Chrome >= 55 (including Opera),
 * Edge >= 13 on the desktop, and iOS 10 and Chrome on mobile.
 *
 * Learn more in https://angular.io/docs/ts/latest/guide/browser-support.html
 */

/***************************************************************************************************
 * BROWSER POLYFILLS
 */

/** IE9, IE10 and IE11 requires all of the following polyfills. **/
// import 'core-js/es6/symbol';
// import 'core-js/es6/object';
// import 'core-js/es6/function';
// import 'core-js/es6/parse-int';
// import 'core-js/es6/parse-float';
// import 'core-js/es6/number';
// import 'core-js/es6/math';
// import 'core-js/es6/string';
// import 'core-js/es6/date';
// import 'core-js/es6/array';
// import 'core-js/es6/regexp';
// import 'core-js/es6/map';
// import 'core-js/es6/weak-map';
// import 'core-js/es6/set';

/** IE10 and IE11 requires the following for NgClass support on SVG elements */
// import 'classlist.js';  // Run `npm install classlist.js`.

/** IE10 and IE11 requires the following for the Reflect API. */
// import 'core-js/es6/reflect';

/** Evergreen browsers require these. **/
// Used for reflect-metadata in JIT. If you use AOT (and only Angular decorators), you can remove.
import "core-js/proposals/reflect-metadata";

/**
 * Required to support Web Animations `@angular/platform-browser/animations`.
 * Needed for: All but Chrome, Firefox and Opera. http://caniuse.com/#feat=web-animation
 **/
// import 'web-animations-js';  // Run `npm install web-animations-js`.

/***************************************************************************************************
 * Zone JS is required by default for Angular itself.
 */
import "zone.js/dist/zone"; // Included with Angular CLI.

/***************************************************************************************************
 * APPLICATION IMPORTS
 */
```

### `src/styles.css`

```css
/* You can add your custom CSS here. */
```

### `src/typings.d.ts`

```ts
/* SystemJS module definition */
declare var module: NodeModule;
interface NodeModule {
    id: string;
}
```

### `.angular-cli.json`

```json
{
  "apps": [
    {
      "root": "src",
      "outDir": "dist",
      "assets": [ "assets", "favicon.ico" ],
      "index": "index.html",
      "main": "main.ts",
      "polyfills": "polyfills.ts",
      "prefix": "app",
      "styles": [ "styles.css" ],
      "scripts": [ ],
      "environmentSource": "environments/environment.ts",
      "environments": {
        "dev": "environments/environment.ts",
        "prod": "environments/environment.prod.ts"
      }
    }
  ]
}
```

### `_tsconfig.json`

```json
{
  "compileOnSave": false,
  "compilerOptions": {
    "baseUrl": "./",
    "outDir": "./dist/out-tsc",
    "sourceMap": true,
    "declaration": false,
    "allowSyntheticDefaultImports": true,
    "downlevelIteration": true,
    "experimentalDecorators": true,
    "moduleResolution": "node",
    "importHelpers": true,
    "resolveJsonModule": true,
    "target": "es2015",
    "module": "es2020",
    "lib": [
      "es2018",
      "dom"
    ]
  }
}
```

### `package.json`

```json
{
  "name": "surveyjs-angular",
  "scripts": {
    "ng": "ng",
    "start": "ng serve",
    "build": "ng build --prod",
    "test": "ng test",
    "lint": "ng lint",
    "e2e": "ng e2e"
  },
  "private": true,
  "dependencies": {
    "@angular/animations": "14.1.1",
    "@angular/cdk": "14.1.1",
    "@angular/common": "14.1.1",
    "@angular/compiler": "14.1.1",
    "@angular/core": "14.1.1",
    "@angular/forms": "14.1.1",
    "@angular/platform-browser": "14.1.1",
    "@angular/platform-browser-dynamic": "14.1.1",
    "@angular/router": "14.1.1",
    "core-js": "3.6.4",
    "rxjs": "6.5.4",
    "survey-core": "latest",
    "survey-angular-ui": "latest",
    "tslib": "1.13.0",
    "zone.js": "0.11.7"
  },
  "devDependencies": {
    "@angular/cli": "1.6.6",
    "@angular/compiler-cli": "^5.2.0",
    "@angular/language-service": "^5.2.0",
    "@types/core-js": "0.9.46",
    "@types/jasmine": "~2.8.3",
    "@types/jasminewd2": "~2.0.2",
    "@types/node": "~6.0.60",
    "codelyzer": "^4.0.1",
    "jasmine-core": "~2.8.0",
    "jasmine-spec-reporter": "~4.2.1",
    "karma": "~2.0.0",
    "karma-chrome-launcher": "~2.2.0",
    "karma-coverage-istanbul-reporter": "^1.2.1",
    "karma-jasmine": "~1.1.0",
    "karma-jasmine-html-reporter": "^0.2.2",
    "protractor": "~5.1.2",
    "ts-node": "~4.1.0",
    "tslint": "~5.9.1",
    "typescript": "3.9.7"
  },
  "keywords": [ "angular", "surveyjs" ],
  "description": "SurveyJS-Angular example project"
}
```

## Other Frameworks

- [React](https://surveyjs.io/form-library/examples/detect-miskeyed-form-entries/reactjs.md)
- [Vue 3](https://surveyjs.io/form-library/examples/detect-miskeyed-form-entries/vue3js.md)
- [jQuery](https://surveyjs.io/form-library/examples/detect-miskeyed-form-entries/jquery.md)
- [Vanilla JS](https://surveyjs.io/form-library/examples/detect-miskeyed-form-entries/vanillajs.md)
